# mypy-boto3-elbv2

[![PyPI - mypy-boto3-elbv2](https://img.shields.io/pypi/v/mypy-boto3-elbv2.svg?color=blue)](https://pypi.org/project/mypy-boto3-elbv2)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-elbv2.svg?color=blue)](https://pypi.org/project/mypy-boto3-elbv2)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-elbv2](#mypy-boto3-elbv2)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.ElasticLoadBalancingv2 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/elbv2.html#ElasticLoadBalancingv2) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-elbv2](#mypy-boto3-elbv2)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `ElasticLoadBalancingv2` service.

```bash
python -m pip install boto3-stubs[elbv2]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_elbv2` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_elbv2 import ElasticLoadBalancingv2Client

# Now mypy can check if your code is valid.
client: ElasticLoadBalancingv2Client = boto3.client("elbv2")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: ElasticLoadBalancingv2Client = session.client("elbv2")



# Waiters are also supported

import mypy_boto3_elbv2.waiter as elbv2_waiters

load_balancer_available_waiter: elbv2_waiters.LoadBalancerAvailableWaiter = client.get_waiter("load_balancer_available")
load_balancer_exists_waiter: elbv2_waiters.LoadBalancerExistsWaiter = client.get_waiter("load_balancer_exists")
load_balancers_deleted_waiter: elbv2_waiters.LoadBalancersDeletedWaiter = client.get_waiter("load_balancers_deleted")
target_deregistered_waiter: elbv2_waiters.TargetDeregisteredWaiter = client.get_waiter("target_deregistered")
target_in_service_waiter: elbv2_waiters.TargetInServiceWaiter = client.get_waiter("target_in_service")


# Annotated paginators are included as well

import mypy_boto3_elbv2.paginator as elbv2_paginators

describe_account_limits_paginator: elbv2_paginators.DescribeAccountLimitsPaginator = client.get_paginator("describe_account_limits")
describe_listener_certificates_paginator: elbv2_paginators.DescribeListenerCertificatesPaginator = client.get_paginator("describe_listener_certificates")
describe_listeners_paginator: elbv2_paginators.DescribeListenersPaginator = client.get_paginator("describe_listeners")
describe_load_balancers_paginator: elbv2_paginators.DescribeLoadBalancersPaginator = client.get_paginator("describe_load_balancers")
describe_rules_paginator: elbv2_paginators.DescribeRulesPaginator = client.get_paginator("describe_rules")
describe_ssl_policies_paginator: elbv2_paginators.DescribeSSLPoliciesPaginator = client.get_paginator("describe_ssl_policies")
describe_target_groups_paginator: elbv2_paginators.DescribeTargetGroupsPaginator = client.get_paginator("describe_target_groups")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_elbv2` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_elbv2 as elbv2
from mypy_boto3_elbv2 import ElasticLoadBalancingv2Client

# with these
from mypy_boto3 import elbv2
from mypy_boto3.elbv2 import ElasticLoadBalancingv2Client
```